using System;

namespace Takmicenje2
{
    class Program
    {
        struct Pacijent
        {
            public string KG;
            public int J;
        }
        enum KrvnaG { O, A, B, AB};

        static bool Moguce2(Pacijent[] nizp, int[] kg)
        {
            int p1 = 0, p2 = 0, p3 = 0;
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "O")
                {
                    if (nizp[i].J > kg[0])
                    {
                        return false;
                    }
                    else
                    {
                        kg[0] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "A")
                {
                    if (nizp[i].J > kg[0])
                    {
                        if (kg[0] != 0)
                        {
                            nizp[i].J -= kg[0];
                            p1 = kg[0];
                            kg[0] = 0;
                        }
                        if (nizp[i].J > kg[1])
                        {
                            return false;
                        }
                        else
                        {
                            kg[1] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        kg[0] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "B")
                {
                    if (nizp[i].J > kg[2])
                    {
                        if (kg[2] != 0)
                        {
                            nizp[i].J -= kg[2];
                            p1 = kg[2];
                            kg[2] = 0;
                        }
                        if (nizp[i].J > kg[0])
                        {
                            return false;
                        }
                        else
                        {
                            kg[0] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        kg[2] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "AB")
                {
                    if (nizp[i].J > kg[0])
                    {
                        if (kg[0] != 0)
                        {
                            nizp[i].J -= kg[0];
                            p1 = kg[0];
                            kg[0] = 0;
                        }
                        if (nizp[i].J > kg[1])
                        {
                            if (kg[1] != 0)
                            {
                                nizp[i].J -= kg[1];
                                p2 = kg[1];
                                kg[1] = 0;
                            }
                            if (nizp[i].J > kg[2])
                            {
                                if (kg[2] != 0)
                                {
                                    nizp[i].J -= kg[2];
                                    p3 = kg[2];
                                    kg[2] = 0;
                                }
                                if (nizp[i].J > kg[3])
                                {
                                    return false;
                                }
                                else
                                {
                                    kg[3] -= nizp[i].J;
                                }
                            }
                            else
                            {
                                kg[2] -= nizp[i].J;
                            }
                        }
                        else
                        {
                            kg[1] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        kg[0] -= nizp[i].J;
                    }
                }
            }
            return true;
        }
        static void Moguce(Pacijent[] nizp, int[] kg)
        {
            int p1 = 0, p2 = 0, p3 = 0;
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "O")
                {
                    if (nizp[i].J > kg[0])
                    {
                        
                    }
                    else
                    {
                        Console.WriteLine("{0} 0 0 0", nizp[i].J);
                        kg[0] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "A")
                {
                    if (nizp[i].J > kg[0])
                    {
                        if (kg[0] != 0)
                        {
                            nizp[i].J -= kg[0];
                            p1 = kg[0];
                            kg[0] = 0;
                        }
                        if (nizp[i].J > kg[1])
                        {
                            
                        }
                        else
                        {
                            Console.WriteLine("{0} {1} 0 0", p1, nizp[i].J);
                            kg[1] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        Console.WriteLine("{0} 0 0 0", nizp[i].J);
                        kg[0] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "B")
                {
                    if (nizp[i].J > kg[2])
                    {
                        if (kg[2] != 0)
                        {
                            nizp[i].J -= kg[2];
                            p1 = kg[2];
                            kg[2] = 0;
                        }
                        if (nizp[i].J > kg[0])
                        {
                            
                        }
                        else
                        {
                            Console.WriteLine("{0} 0 {1} 0", nizp[i].J, p1);
                            kg[0] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        Console.WriteLine("0 0 {0} 0", nizp[i].J);
                        kg[2] -= nizp[i].J;
                    }
                }
            }
            for (int i = 0; i < nizp.Length; i++)
            {
                if (nizp[i].KG == "AB")
                {
                    if (nizp[i].J > kg[0])
                    {
                        if (kg[0] != 0)
                        {
                            nizp[i].J -= kg[0];
                            p1 = kg[0];
                            kg[0] = 0;
                        }
                        if (nizp[i].J > kg[1])
                        {
                            if (kg[1] != 0)
                            {
                                nizp[i].J -= kg[1];
                                p2 = kg[1];
                                kg[1] = 0;
                            }
                            if (nizp[i].J > kg[2])
                            {
                                if (kg[2] != 0)
                                {
                                    nizp[i].J -= kg[2];
                                    p3 = kg[2];
                                    kg[2] = 0;
                                }
                                if (nizp[i].J > kg[3])
                                {
                                    
                                }
                                else
                                {
                                    Console.WriteLine("{0} {1} {2} {3}", p1, p2, p3, nizp[i].J);
                                    kg[3] -= nizp[i].J;
                                }
                            }
                            else
                            {
                                Console.WriteLine("{0} {1} {2} 0", p1, p2, nizp[i].J);
                                kg[2] -= nizp[i].J;
                            }
                        }
                        else
                        {
                            Console.WriteLine("{0} {1} 0 0", p1, nizp[i].J);
                            kg[1] -= nizp[i].J;
                        }
                    }
                    else
                    {
                        Console.WriteLine("{0} 0 0 0", nizp[i].J);
                        kg[0] -= nizp[i].J;
                    }
                }
            }
        }

        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] s = Console.ReadLine().Split(' ');
            int[] kg = new int[4];
            int[] kg2 = new int[4];

            for (int i = 0; i < kg.Length; i++)
            {
                kg[i] = int.Parse(s[i]);
                kg2[i] = int.Parse(s[i]);
            }

            Pacijent[] nizp = new Pacijent[n];
            Pacijent[] nizp2 = new Pacijent[n];
            string[] ss;

            for (int i = 0; i < n; i++)
            {
                ss = Console.ReadLine().Split(' ');
                Pacijent x = new Pacijent();
                x.KG = ss[0];
                x.J = int.Parse(ss[1]);
                nizp[i] = x;
                nizp2[i] = x;
            }

            if (Moguce2(nizp, kg))
            {
                Console.WriteLine("moguce");
            }
            else
            {
                Console.WriteLine("nemoguce");
            }
            Moguce(nizp2, kg2);
        }
    }
}